/*
 * Copyright 2001-2003, Broadcom Corporation
 * All Rights Reserved.
 *
 *
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
 *
 */

/*
 * Copyright 2001-2003, Broadcom Corporation
 * All Rights Reserved.
 *
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
 *
 */
/*
 * BCM4310 address space map and definitions
 * Think twice before adding to this file, this is not the kitchen sink
 * These definitions are not guaranteed for all 47xx chips, only the 4310
 *
 * $Id: bcm4310.h,v 13.1 2002/07/17 22:50:50 noname Exp $
 */

#ifndef _bcm4310_h_
#define _bcm4310_h_

/* Address map */
#define BCM4310_SDRAM		0x00000000	/* Physical SDRAM */
#define BCM4310_PCI_MEM		0x08000000	/* Host Mode PCI memory access space (64 MB) */
#define BCM4310_PCI_CFG		0x0c000000	/* Host Mode PCI configuration space (64 MB) */
#define BCM4310_PCI_DMA		0x40000000	/* Client Mode PCI memory access space (1 GB) */
#define	BCM4310_SDRAM_SWAPPED	0x10000000	/* Byteswapped Physical SDRAM */
#define BCM4310_ENUM		0x18000000	/* Beginning of core enumeration space */

/* Core register space */
#define BCM4310_REG_CHIPC	0x18000000	/* Chipcommon core registers */
#define BCM4310_REG_D11		0x18001000	/* 802.11 MAC core registers */
#define BCM4310_REG_EMAC0	0x18002000	/* Ethernet MAC 0 core registers */
#define BCM4310_REG_EMAC1	0x18003000	/* Ethernet MAC 1 core registers */
#define BCM4310_REG_USB		0x18004000	/* USB core registers */
#define BCM4310_REG_PCI		0x18005000	/* PCI core registers */
#define BCM4310_REG_MIPS	0x18006000	/* MIPS core registers */
#define BCM4310_REG_SDRAM	0x18007000	/* SDRAM core registers */

#define	SBFLAG_PCI	0
#define	SBFLAG_ENET0	1
#define	SBFLAG_D11	2
#define	SBFLAG_MIPS	3
#define	SBFLAG_USB	4
#define	SBFLAG_CC	5
#define	SBFLAG_ENET1	6

#endif /* _bcm4310_h_ */
